﻿using System;
using System.Collections.Generic;

using System.Web;
using System.Text;
using System.Security.Cryptography;


namespace ServiceTestClient
{
    public class Authenticate
    {

        public static ServiceTestClient.TransactionService.Authentication GetTransactionAuthTicket(string strAPILoginID, string strKey)
        {
            ServiceTestClient.TransactionService.Authentication ticket = new ServiceTestClient.TransactionService.Authentication();
            ticket.APILoginID = strAPILoginID;
            ticket.UTCTime = DateTime.UtcNow.Ticks.ToString();
            ticket.TSHash = CalculateHMACMD5(ticket.APILoginID + "|" + ticket.UTCTime, strKey.Trim());

            return ticket;
        }

        public static ServiceTestClient.ClientService.Authentication GetClientAuthTicket(string strAPILoginID, string strKey)
        {
            ServiceTestClient.ClientService.Authentication ticket = new ServiceTestClient.ClientService.Authentication();
            ticket.APILoginID = strAPILoginID;
            ticket.UTCTime = DateTime.UtcNow.Ticks.ToString();
            ticket.TSHash = CalculateHMACMD5(ticket.APILoginID + "|" + ticket.UTCTime, strKey.Trim());

            return ticket;
        }

        public static string CalculateHMACMD5(string input, string key)
        {
            StringBuilder sb = new StringBuilder();
            byte[] data = Encoding.Default.GetBytes(input);
            byte[] secretkey = new byte[64];
            secretkey = Encoding.Default.GetBytes(key);
            HMACMD5 hmacMD5 = new HMACMD5(secretkey);
            byte[] macSender = hmacMD5.ComputeHash(data);

            for (int i = 0; i < macSender.Length; i++)
                sb.Append(macSender[i].ToString("x2"));

            return sb.ToString();
        }
    }
}
