﻿using System;
using System.Collections.Generic;

using System.Web;
using System.Web.UI.WebControls;
using ServiceTestClient.TransactionService;


namespace ServiceTestClient
{
    public partial class TestReceivedDetail : System.Web.UI.Page
    {
        protected void btnSettle_Click(object sender, EventArgs e)
        {
            DoSearch(0, Convert.ToInt32(txtPageSize.Text));
        }

        private void DoSearch(int pageIndex, int pageSize)
        {
            try
            {
                using (TransactionServiceClient proxy = new TransactionServiceClient("WSHttpBinding"))
                {
                    int TotalRecords = 0;
                    DateTime day = Convert.ToDateTime(txtDay.Text);

                    int MerchantID = Convert.ToInt32(txtMID.Text);

                    grid.DataSource = proxy.getReceivedDetail(Authenticate.GetTransactionAuthTicket(txtID.Text.Trim(), txtKey.Text.Trim()), MerchantID, day, pageIndex, pageSize, out TotalRecords);
                    grid.DataBind();


                    lblMsg.Text = string.Empty;
                    lblInfo.Text = "Total records count: " + TotalRecords.ToString();
                    if (TotalRecords > 0)
                        lblInfo.Text += "<br>Showing record#: " + (pageIndex * pageSize + 1).ToString() + " to " + ((TotalRecords < (pageIndex + 1) * pageSize) ? TotalRecords.ToString() : ((pageIndex + 1) * pageSize).ToString());

                    //show pager if TotalRecords > PageSize
                    if (TotalRecords > Convert.ToInt32(txtPageSize.Text))
                    {
                        int totalpages = TotalRecords / Convert.ToInt32(txtPageSize.Text) + 1;
                        divPager.Visible = true;
                        lnkPrev.Enabled = (pageIndex > 0);
                        lnkNext.Enabled = (pageIndex < totalpages - 1);
                        //load avaliable page number
                        lstPage.Items.Clear();
                        for (int i = 0; i < totalpages; i++)
                        {
                            lstPage.Items.Add(i.ToString());
                        }
                        lstPage.SelectedValue = pageIndex.ToString();

                    }
                    else
                        divPager.Visible = false;
                }
            }
            catch (Exception ex)
            {
                lblMsg.Text = ex.Message + "<br>";
                lblInfo.Text = string.Empty;
            }
        }

        #region Paging
        protected void lnkNext_Click(object sender, EventArgs e)
        {
            DoSearch(Convert.ToInt32(lstPage.SelectedValue) + 1, Convert.ToInt32(txtPageSize.Text));
        }

        protected void lnkPrev_Click(object sender, EventArgs e)
        {
            DoSearch(Convert.ToInt32(lstPage.SelectedValue) - 1, Convert.ToInt32(txtPageSize.Text));
        }

        protected void lstPage_SelectedIndexChanged(object sender, EventArgs e)
        {
            DoSearch(Convert.ToInt32(lstPage.SelectedValue), Convert.ToInt32(txtPageSize.Text));
        }
        #endregion

    }
}
