﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using ServiceTestClient.TransactionService;
using System.Text;
using System.Security.Cryptography;
using System.Reflection;


namespace ServiceTestClient
{
    public partial class TestTransaction : System.Web.UI.Page
    {
        protected void btnGetTransDetail_Click(object sender, EventArgs e)
        {
            try
            {
                using (TransactionServiceClient proxy = new TransactionServiceClient("WSHttpBinding"))
                {
                    Transaction tran = proxy.getTransaction(Authenticate.GetTransactionAuthTicket(txtID.Text.Trim(), txtKey.Text.Trim()), Convert.ToInt32(txtMID.Text), txtTransID.Text);
                    
                    //show the transaction in a grid
                    grid.DataSource = new List<Transaction> { tran };
                    grid.DataBind();

                    //show the transaction response in a grid
                    gridResponse.DataSource = new List<TransactionResponse> { tran.Response };
                    gridResponse.DataBind();

                    //show the lineitems in a grid
                    gridLineItem.DataSource = tran.LineItems;
                    gridLineItem.DataBind();

                    lblMsg.Text = string.Empty;
                }
            }
            catch (Exception ex)
            {
                lblMsg.Text = ex.Message + "<br>";
            }
        }
    }
}
